﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EasyPortal.Web.Weibo
{
    /// <summary>
    /// Credential persistence interface.
    /// </summary>
    public interface ICredentialPersistence
    {
        /// <summary>
        /// Sets the request credential.
        /// </summary>
        /// <param name="requestCredential">The request credential.</param>
        void SetRequest(Credential requestCredential);

        /// <summary>
        /// Gets the request credential.
        /// </summary>
        /// <returns>The request credential.</returns>
        Credential GetRequest();

        /// <summary>
        /// Clear the request credential.
        /// </summary>
        void ClearRequest();

        /// <summary>
        /// Sets the access credential.
        /// </summary>
        /// <param name="accessCredential">The access credential.</param>
        void SetAccess(Credential accessCredential);

        /// <summary>
        /// Gets the access credential.
        /// </summary>
        /// <returns>The access credential.</returns>
        Credential GetAccess();
    }
}
