﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EasyPortal.Web.Weibo.Sina;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace Sina.Controllers
{
    public class BestFriendController : CommonController
    {
        //
        // GET: /BestFriend/

        //取最近100条
        const int Count = 100;

        public ActionResult Index()
        {
            if (ViewBag.UserId != null)
            {
                #region Follower

                List<string> followersList = new List<string>();
                int followersCursor=-1;
                do
                {

                    string followersJson = SinaApi.Json.Statuses_Followers(ViewBag.UserId, Count, followersCursor).Text;
                    JObject followerObj = JsonConvert.DeserializeObject<JObject>(followersJson);
                    if (followerObj["next_cursor"] != null)
                        followersCursor = int.Parse(followerObj["next_cursor"].ToString());
                    foreach (JToken jt in followerObj["users"])
                    {

                        followersList.Add(jt["id"].ToString() + "|" + jt["name"].ToString());
                    }
                }
                while (followersCursor > 0);

                ViewBag.Followers = string.Join(";", followersList);

                #endregion

                #region Mentions

                //@的微博消息列表
                string mentionsJson = SinaApi.Json.Statuses_Mentions(null, null, Count, null).Text;
                JArray mentionsArray = JsonConvert.DeserializeObject<JArray>(mentionsJson);

                List<string> mentionsList = new List<string>();

                foreach (JToken jt in mentionsArray)
                {
                    mentionsList.Add(jt["user"]["id"].ToString() + "|" + jt["user"]["name"].ToString());
                }

                ViewBag.Mentions = string.Join(";", mentionsList);

                #endregion

                #region Comments By Me

                //评论别人
                string commentsByMeJson = SinaApi.Json.Statuses_Comments_By_Me(null, null, Count, null).Text;
                JArray commentsByMeArray = JsonConvert.DeserializeObject<JArray>(commentsByMeJson);

                List<string> commentsByMeList = new List<string>();

                foreach (JToken jt in commentsByMeArray)
                {
                    if (jt["reply_comment"] != null)
                    {
                        JToken jtTemp = jt["reply_comment"];
                        commentsByMeList.Add(jtTemp["user"]["id"].ToString() + "|" + jtTemp["user"]["name"].ToString());
                    }
                    else
                    {
                        if (jt["status"] != null)
                        {
                            JToken jtTemp = jt["status"];
                            commentsByMeList.Add(jtTemp["user"]["id"].ToString() + "|" + jtTemp["user"]["name"].ToString());
                        }
                    }
                }

                ViewBag.CommentsByMe = string.Join(";", commentsByMeList);

                #endregion

                #region Comments To Me

                //别人评论我
                string commentsToMeJson = SinaApi.Json.Statuses_Comments_To_Me(null, null, Count, null).Text;
                JArray commentsToMeArray = JsonConvert.DeserializeObject<JArray>(commentsToMeJson);

                List<string> commentsToMeList = new List<string>();

                foreach (JToken jt in commentsToMeArray)
                {
                    commentsToMeList.Add(jt["user"]["id"].ToString() + "|" + jt["user"]["name"].ToString());
                }

                ViewBag.CommentsToMe = string.Join(";", commentsToMeList);

                #endregion

                #region Report By Me

                string reportByMeJson =SinaApi.Json.Statuses_Repost_By_Me(long.Parse(ViewBag.UserId), null, null, Count, null).Text;
                JArray reportByMeArray = JsonConvert.DeserializeObject<JArray>(reportByMeJson);

                List<string> reportByMeList = new List<string>();

                foreach (JToken jt in reportByMeArray)
                {
                    if (jt["retweeted_status"] != null)
                    {
                        JToken jtTemp = jt["retweeted_status"];
                        reportByMeList.Add(jtTemp["user"]["id"].ToString() + "|" + jtTemp["user"]["name"].ToString());
                    }
                }

                ViewBag.ReportByMe = string.Join(";", reportByMeList);

                #endregion

                #region Report To Me
                //原创微博
                string userTimelineJson = SinaApi.Json.Statuses_User_Timeline(ViewBag.UserId, null, null, Count, null, null, 1).Text;
                JArray userTimelineArray = JsonConvert.DeserializeObject<JArray>(userTimelineJson);

                List<string> userTimelineList = new List<string>();

                foreach (JToken jt in userTimelineArray)
                {
                    string repostTimelineJson = SinaApi.Json.Statuses_Repost_Timeline(jt["id"].Value<long>(), null, null, Count, null).Text;
                    JArray repostTimelineArray = JsonConvert.DeserializeObject<JArray>(repostTimelineJson);
                    foreach (JToken jt2 in repostTimelineArray)
                    {
                        userTimelineList.Add(jt2["user"]["id"].ToString() + "|" + jt2["user"]["name"].ToString());
                    }

                }
                ViewBag.ReportToMe = string.Join(";", userTimelineList);

                #endregion
            }
            return View();
        }

    }
}
